package lbi.jdbc.sampling;

import lbi.utils.*;

import java.io.*;
import java.sql.*;
import java.util.*;

public class StratifiedSampling {

	   public static final double PERCENTAGE=0.30;

	   public static void randomCSV(ResultSet rs, PrintWriter os, int tot, int to_sel) 
	   throws SQLException {
	        ResultSetMetaData md = rs.getMetaData();
//	 number of columns
	        int nCols = md.getColumnCount();
//	 output result set choosing to_sel rows randomly from tot
	        while (rs.next()) {
	        	// probability of selecting current row
	        	double prob = to_sel / (double) tot;
	        	if( Math.random() < prob ) {
		            for (int i = 1; i < nCols; ++i)
		                os.print(rs.getString(i) + ",");
		            os.println(rs.getString(nCols));
	        		--to_sel;
	        	}
        		--tot;
	        }
//	 flush printwriter
	        os.flush();
	    }


	    public static void main(String[] args) throws SQLException, IOException {
//	 load proprierties
	        Properties props = IOUtil.readProps("myJDBCdef.props");
//	 load drivers
	        DBUtil.loadJDBC(props.getProperty("jdbcDriver"));
//	 connect to data source, using userName and userPWD
	        String url = props.getProperty("jdbcURL");
	        String user = props.getProperty("userName");
	        String pwd = props.getProperty("userPWD");
	        Connection con = DriverManager.getConnection(url, user, pwd);
	        Statement stmt = con.createStatement();
//	   	 retrieve table and column from properties
	        String table = props.getProperty("tableStrat");
	        String column = props.getProperty("columnStrat");
	        PrintWriter output = IOUtil.getWriter("");
	        ResultSet rs = stmt.executeQuery(
					"SELECT " + column + ", COUNT(*)" +
					" FROM " + table +
					" GROUP BY " + column);
			while( rs.next() ) {
				String colValue = rs.getString(1);
				int nRows = rs.getInt(2);
				int selRows = (int)( nRows * PERCENTAGE );
		        Statement innerStmt = con.createStatement();
		    	ResultSet innerRs = innerStmt.executeQuery(
						"SELECT *" +
						" FROM " + table +
						" WHERE " + column + "='"+colValue+"'");
		    	randomCSV(innerRs, output, nRows, selRows);
			}
	        output.close();
	        con.close();
	    }
	}