package lbi.jdbc.sampling;

import lbi.utils.*;

import java.io.*;
import java.sql.*;
import java.util.*;

public class StratifiedSamplingSQLServer {
	
		public static final double PERCENTAGE=0.30;

	    public static void main(String[] args) throws SQLException, IOException {
//	 load proprierties
	        Properties props = IOUtil.readProps("myJDBCdef.props");
//	 load drivers
	        DBUtil.loadJDBC(props.getProperty("jdbcDriver"));
//	 connect to data source, using userName and userPWD
	        String url = props.getProperty("jdbcURL");
	        String user = props.getProperty("userName");
	        String pwd = props.getProperty("userPWD");
	        Connection con = DriverManager.getConnection(url, user, pwd);
	        Statement stmt = con.createStatement();
//	 retrieve table and column from properties
	        String table = props.getProperty("tableStrat");
	        String column = props.getProperty("columnStrat");

	        PrintWriter output = IOUtil.getWriter("");
	        ResultSet rs = stmt.executeQuery(
					"SELECT " + column + ", COUNT(*)" +
					" FROM " + table +
					" GROUP BY " + column);
			while( rs.next() ) {
				String colValue = rs.getString(1);
				int nRows = rs.getInt(2);
				int selRows = (int)( nRows * PERCENTAGE );
		        Statement innerStmt = con.createStatement();
		    	ResultSet innerRs = innerStmt.executeQuery(
						"SELECT TOP " + selRows + " *" +
						" FROM " + table +
						" WHERE " + column + "='"+colValue+"'" +
						" ORDER BY newid()"); // SQL-Server specific syntax for random selection
		    	DBUtil.toCSV(innerRs, output, false);
			}
	        output.close();
	        con.close();
	    }
	}